-- EE552 Sign Language Glove Project

-- This program debounces a push button

library ieee;
use ieee.std_logic_1164.all;
library work;
use work.SLG_pkg.all;

entity debouncer is
	generic(
		CLOCK_DIV		: positive := 4
	);
	port(
		clock			: in std_logic;
		reset			: in std_logic;
		signal_in		: in std_logic;
		signal_out		: out std_logic
	);

end entity debouncer;

architecture rtl of debouncer is

signal clk_divided : std_logic;

begin

	debounce : component clk_divider
	generic map (CLOCK_DIV => CLOCK_DIV)
	port map (reset => reset, clk_in => clock, clk_out => clk_divided);

	process(clock) is
	begin

		if rising_edge(clk_divided) then
			signal_out <= signal_in;
		end if;
		
	end process;

end rtl; 
